﻿using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AutohideTab119980
{

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Docking.AutoHideAnimationStart += Dock_AutoHideAnimationStart;
        }

        void Dock_AutoHideAnimationStart(object sender, RoutedEventArgs e)
        {
            Dock dockside = DockingManager.GetSidePanelDock(e.OriginalSource as FrameworkElement);
            SidePanel sidepanel = FindDescendant(Docking, typeof(SidePanel), dockside) as SidePanel;
            if (sidepanel != null && sidepanel.PanelSide == dockside && sidepanel.IsContentHiden)
                Console.WriteLine("AutoHide Panel opening");
        }
        public static Visual FindDescendant(Visual startingFrom, Type typeDescendant, Dock side)
        {
            Visual visual = null;
            bool result = false;
            int iCount = VisualTreeHelper.GetChildrenCount(startingFrom);

            for (int i = 0; i < iCount; ++i)
            {
                Visual child = VisualTreeHelper.GetChild(startingFrom, i) as Visual;

                if (typeDescendant.IsInstanceOfType(child))
                {
                    visual = child;
                    if (visual is SidePanel && (visual as SidePanel).PanelSide == side)
                        result = true;
                }

                if (!result)
                {
                    if (child != null)
                    {
                        visual = FindDescendant(child, typeDescendant, side);

                        if (visual != null)
                        {
                            break;
                        }
                    }
                }
                else
                {
                    break;
                }
            }

            return visual;
        }
    }
}
